Scriptname ZSH_V2_PuzzleScript01 extends Quest

ObjectReference Property ZSH_Tomb_OpenDoor Auto
ObjectReference Property ZSH_Tomb_CloseDoor Auto
ObjectReference Property ZSH_Tomb_ToggleDoor Auto
Bool Property ActivationEnabled Auto

GlobalVariable Property ZSH_MCM_Quest Auto
;----------------------------------------------------------------------------------------------------------
;	 CULTIST BATTLE
;----------------------------------------------------------------------------------------------------------
Actor Property CultistBossRef01 Auto
Actor Property CultistRef01 Auto
Actor Property CultistRef02 Auto
Actor Property CultistRef03 Auto
ObjectReference Property PortalDoor Auto
ObjectReference Property HallwayDoor Auto

Function CultistDeath()
If (CultistBossRef01.IsDead()) && (CultistRef01.IsDead()) && (CultistRef02.IsDead()) && (CultistRef03.IsDead()) && (ZSH_MCM_Quest.GetValue() == 0)
	ZSH_MCM_Quest.SetValue(1)
	SetStage(40)
	PortalDoor.Enable()

	Utility.Wait(0.1)
	PortalDoor.PlayAnimation("playAnim02")
	PortalDoor.GetLinkedRef().Activate(Game.GetPlayer())
	HallwayDoor.Activate(ZSH_Tomb_OpenDoor)
Endif
EndFunction

;----------------------------------------------------------------------------------------------------------
;	 FINAL PUZZLE
;----------------------------------------------------------------------------------------------------------
ObjectReference Property ZSH_Final_Door01 Auto
ObjectReference Property ZSH_Final_Door02 Auto
ObjectReference Property ZSH_Final_Door03 Auto
ObjectReference Property ZSH_Final_Door04 Auto

ObjectReference Property ZSH_Tomb_PuzzleESW Auto
ObjectReference Property ZSH_Tomb_PuzzleWDF Auto
ObjectReference Property ZSH_Tomb_PuzzleBOM Auto

Function FinalPullBar(Bool ToogleDoor01)
If ToogleDoor01 == True
	ZSH_Final_Door02.Activate(ZSH_Tomb_CloseDoor)
	ZSH_Final_Door03.Activate(ZSH_Tomb_CloseDoor)
	ZSH_Final_Door04.Activate(ZSH_Tomb_CloseDoor)
	ZSH_Final_Door01.Activate(ZSH_Tomb_ToggleDoor)
Else
	If (ZSH_Tomb_PuzzleESW.GetState() == "position01") && (ZSH_Tomb_PuzzleBOM.GetState() == "position02") && (ZSH_Tomb_PuzzleWDF.GetState() == "position03") 	; Eagle, Owl, Wolf
		ResolveDoorways(1)
	ElseIf (ZSH_Tomb_PuzzleESW.GetState() == "position02") && (ZSH_Tomb_PuzzleBOM.GetState() == "position01") && (ZSH_Tomb_PuzzleWDF.GetState() == "position02") 	; Snake, Moth, Fox
		ResolveDoorways(2)
	ElseIf (ZSH_Tomb_PuzzleESW.GetState() == "position03") && (ZSH_Tomb_PuzzleBOM.GetState() == "position03") && (ZSH_Tomb_PuzzleWDF.GetState() == "position01") 	; Whale, Bear, Dragon
		ResolveDoorways(3)
	ElseIf (ZSH_Tomb_PuzzleESW.GetState() == "position02") && (ZSH_Tomb_PuzzleBOM.GetState() == "position01") && (ZSH_Tomb_PuzzleWDF.GetState() == "position01") 	; Snake, Moth, Dragon
		ResolveDoorways(4)
	Endif
Endif
EndFunction

Function ResolveDoorways(Int DoorToOpen)
Utility.Wait(0.5)
	If !(DoorToOpen == 1)
		ZSH_Final_Door01.Activate(ZSH_Tomb_CloseDoor)
	Endif
	If !(DoorToOpen == 2)
		ZSH_Final_Door02.Activate(ZSH_Tomb_CloseDoor)
	Endif
	If !(DoorToOpen == 3)
		ZSH_Final_Door03.Activate(ZSH_Tomb_CloseDoor)
	Endif
	If !(DoorToOpen == 4)
		ZSH_Final_Door04.Activate(ZSH_Tomb_CloseDoor)
	Endif
	If (DoorToOpen == 1)
		ZSH_Final_Door01.Activate(ZSH_Tomb_OpenDoor)
	Elseif (DoorToOpen == 2)
		ZSH_Final_Door02.Activate(ZSH_Tomb_OpenDoor)
	Elseif (DoorToOpen == 3)
		ZSH_Final_Door03.Activate(ZSH_Tomb_OpenDoor)
	Elseif (DoorToOpen == 4)
		ZSH_Final_Door04.Activate(ZSH_Tomb_OpenDoor)
	Endif
EndFunction