Scriptname ZSH_V2_QuestScript01 extends Quest

Actor HeroActor
Actor Property AlfragOrcFriend Auto
Actor Property AlysonBlacksted Auto
Actor Property OrfedIceHoof Auto
Actor Property BethynIcebrood Auto
Actor Property AlfredBlacksted Auto

ObjectReference ChosenSpawner
ObjectReference Property ZSH_Arena_Spawner01 Auto
ObjectReference Property ZSH_Arena_Spawner02 Auto
ObjectReference Property ZSH_Arena_Spawner03 Auto
ObjectReference Property ZSH_Arena_Spawner04 Auto
ObjectReference Property ZSH_Arena_Spawner05 Auto
ObjectReference Property ZSH_Arena_Spawner06 Auto
ObjectReference Property ZSH_Arena_Spawner07 Auto
ObjectReference Property ZSH_Arena_Spawner08 Auto

Actor Property Aeonbarr Auto
Sound Property ZSH_Arena_ApproachingSound Auto
ObjectReference Property AeonbarrNirnMarker Auto
ObjectReference Property ZSH_QuestReturnMarker Auto
Quest Property ZSH_AeonbarrQuest Auto
ImageSpaceModifier Property BlackImod Auto

Activator Property ZSH_Tomb_WarriorSummon Auto

Spell Property ZSH_Arena_HealSpell Auto
Spell Property ZSH_Summon_MasterAb Auto

ObjectReference Property ZSH_AeonbarrMarker00 Auto

MiscObject Property ZSH_Token Auto

Function BeginChallenge()
	SetObjectiveDisplayed(50)
	Utility.Wait(0.1)
	HeroActor = AlfragOrcFriend
	ResetCombat()
EndFunction

;-----------------------------------------------------------------------------------------------------------
;	CHALLENGE RESET
;-----------------------------------------------------------------------------------------------------------

Function ResetCombat()
	HealPlayer()
	SelectSpawnPoint()
	Utility.Wait(1)
	HeroActor.MoveTo(ChosenSpawner)
	HeroActor.PlaceAtMe(ZSH_Tomb_WarriorSummon)
	(HeroActor as ZSH_V2_WarriorGhostScript01).ActivateWarrior()
	HeroActor.StartCombat(Game.GetPlayer())
EndFunction

Function SelectSpawnPoint()
	Float Distance01 = (ZSH_Arena_Spawner01.GetDistance(Game.GetPlayer())) as Float
	Float Distance02 = (ZSH_Arena_Spawner02.GetDistance(Game.GetPlayer())) as Float
	Float Distance03 = (ZSH_Arena_Spawner03.GetDistance(Game.GetPlayer())) as Float
	Float Distance04 = (ZSH_Arena_Spawner04.GetDistance(Game.GetPlayer())) as Float
	Float Distance05 = (ZSH_Arena_Spawner05.GetDistance(Game.GetPlayer())) as Float
	Float Distance06 = (ZSH_Arena_Spawner06.GetDistance(Game.GetPlayer())) as Float
	Float Distance07 = (ZSH_Arena_Spawner07.GetDistance(Game.GetPlayer())) as Float
	Float Distance08 = (ZSH_Arena_Spawner08.GetDistance(Game.GetPlayer())) as Float

	If (Distance01 >= Distance02) && (Distance01 >= Distance03) && (Distance01 >= Distance04) && (Distance01 >= Distance05) \
	    && (Distance01 >= Distance06) && (Distance01 >= Distance07) && (Distance01 >= Distance08)
		ChosenSpawner = ZSH_Arena_Spawner01
	ElseIf (Distance02 >= Distance02) && (Distance02 >= Distance03) && (Distance02 >= Distance04) && (Distance02 >= Distance05) \
	    && (Distance02 >= Distance06) && (Distance02 >= Distance07) && (Distance02 >= Distance08)
		ChosenSpawner = ZSH_Arena_Spawner02
	ElseIf (Distance03 >= Distance02) && (Distance03 >= Distance03) && (Distance03 >= Distance04) && (Distance03 >= Distance05) \
	    && (Distance03 >= Distance06) && (Distance03 >= Distance07) && (Distance03 >= Distance08)
		ChosenSpawner = ZSH_Arena_Spawner03
	ElseIf (Distance04 >= Distance02) && (Distance04 >= Distance03) && (Distance04 >= Distance04) && (Distance04 >= Distance05) \
	    && (Distance04 >= Distance06) && (Distance04 >= Distance07) && (Distance04 >= Distance08)
		ChosenSpawner = ZSH_Arena_Spawner04
	ElseIf (Distance05 >= Distance02) && (Distance05 >= Distance03) && (Distance05 >= Distance04) && (Distance05 >= Distance05) \
	    && (Distance05 >= Distance06) && (Distance05 >= Distance07) && (Distance05 >= Distance08)
		ChosenSpawner = ZSH_Arena_Spawner05
	ElseIf (Distance06 >= Distance02) && (Distance06 >= Distance03) && (Distance06 >= Distance04) && (Distance06 >= Distance05) \
	    && (Distance06 >= Distance06) && (Distance06 >= Distance07) && (Distance06 >= Distance08)
		ChosenSpawner = ZSH_Arena_Spawner06
	ElseIf (Distance07 >= Distance02) && (Distance07 >= Distance03) && (Distance07 >= Distance04) && (Distance07 >= Distance05) \
	    && (Distance07 >= Distance06) && (Distance07 >= Distance07) && (Distance07 >= Distance08)
		ChosenSpawner = ZSH_Arena_Spawner07
	Else
		ChosenSpawner = ZSH_Arena_Spawner08
	Endif
EndFunction

Function HealPlayer()
	Game.GetPlayer().DoCombatSpellApply(ZSH_Arena_HealSpell, Game.GetPlayer())
EndFunction

Function HeroDeath(Actor DefeatedHero)
If DefeatedHero == AlfragOrcFriend
	HeroActor = AlysonBlacksted 
	Utility.Wait(5)
	ResetCombat()
Elseif DefeatedHero == AlysonBlacksted 
	HeroActor = OrfedIceHoof 
	Utility.Wait(5)
	ResetCombat()
Elseif  DefeatedHero == OrfedIceHoof 
	HeroActor = BethynIcebrood 
	Utility.Wait(5)
	ResetCombat()
Elseif  DefeatedHero == BethynIcebrood 
	HeroActor = AlfredBlacksted 
	Utility.Wait(5)
	ResetCombat()
Elseif  DefeatedHero == AlfredBlacksted 
	Utility.Wait(3)
	SetStage(60)
Endif
EndFunction

;-----------------------------------------------------------------------------------------------------------
;	E N D   T R I A L
;-----------------------------------------------------------------------------------------------------------
Int Hero01Ready = 0
Int Hero02Ready = 0
Int Hero03Ready = 0
Int Hero04Ready = 0
Int Hero05Ready = 0

Function HeroReady(Actor KneelingHero)
If KneelingHero == AlfragOrcFriend
	Hero01Ready = 1
ElseIf KneelingHero == AlysonBlacksted 
	Hero02Ready = 1
ElseIf KneelingHero == OrfedIceHoof 
	Hero03Ready = 1
ElseIf KneelingHero == BethynIcebrood 
	Hero04Ready = 1
ElseIf KneelingHero == AlfredBlacksted 
	Hero05Ready = 1
Endif

If (Hero01Ready == 1) && (Hero02Ready == 1) && (Hero03Ready == 1) && (Hero04Ready == 1) && (Hero05Ready == 1)
	CallAeonbarr()
Endif
EndFunction

Function CallAeonbarr()
	ZSH_Arena_ApproachingSound.Play(Game.GetPlayer())
	Utility.Wait(5.4)
	AeonbarrNirnMarker.MoveTo(AeonbarrNirnMarker.GetLinkedRef())
	(ZSH_AeonbarrQuest as ZSH_V2_AeonbarrScript01).RequestSummon()

	Utility.Wait(1)
	SetStage(70)
	While !(Game.GetPlayer().IsOnMount())
		Utility.Wait(0.1)
	EndWhile
	Game.DisablePlayerControls()
	
	Utility.Wait(2)

	ZSH_AeonbarrMarker00.MoveTo(ZSH_QuestReturnMarker)
	(ZSH_AeonbarrQuest as ZSH_V2_AeonbarrScript01).AeonbarrReturn()
	Game.GetPlayer().AddSpell(ZSH_Summon_MasterAb)
	Game.EnablePlayerControls()
	SetStage(80)
EndFunction
