Scriptname ZSH_V2_WarriorGhostScript01 extends Actor  

Activator Property ZSH_Tomb_WarriorSummon Auto
Quest Property ZSH_BlackstedQuest Auto

ActorBase Property ZSH_Tomb_Warrior02 Auto
Weapon DaggerType
Weapon Property ZSH_Tomb_Warrior02_Weapon01 Auto
Weapon Property ZSH_Tomb_Warrior02_Weapon11 Auto
Weapon Property ZSH_Tomb_Warrior02_Weapon19 Auto
Weapon Property ZSH_Tomb_Warrior02_Weapon27 Auto
Weapon Property ZSH_Tomb_Warrior02_Weapon36 Auto
Weapon Property ZSH_Tomb_Warrior02_Weapon46 Auto

ActorBase Property ZSH_Tomb_Warrior03 Auto
Spell Property ConjureFrostAtronach Auto

ActorBase Property ZSH_Tomb_Warrior04 Auto
Spell Property ConjureFlameAtronach Auto

Function ActivateWarrior()
	Enable(False)
	BlockActivation(True)
	Self.SetAlpha(0.5, False)
	GetActorBase().SetEssential(True)

	If GetActorBase() == ZSH_Tomb_Warrior02
		If GetItemCount(ZSH_Tomb_Warrior02_Weapon01) >= 1
			DaggerType = ZSH_Tomb_Warrior02_Weapon01
		ElseIf GetItemCount(ZSH_Tomb_Warrior02_Weapon11) >= 1
			DaggerType = ZSH_Tomb_Warrior02_Weapon11
		ElseIf GetItemCount(ZSH_Tomb_Warrior02_Weapon19) >= 1
			DaggerType = ZSH_Tomb_Warrior02_Weapon19
		ElseIf GetItemCount(ZSH_Tomb_Warrior02_Weapon27) >= 1
			DaggerType = ZSH_Tomb_Warrior02_Weapon27
		ElseIf GetItemCount(ZSH_Tomb_Warrior02_Weapon36) >= 1
			DaggerType = ZSH_Tomb_Warrior02_Weapon36
		ElseIf GetItemCount(ZSH_Tomb_Warrior02_Weapon46) >= 1
			DaggerType = ZSH_Tomb_Warrior02_Weapon46
		Endif
		EquipItemEx(DaggerType, 1, True, True)
		EquipItemEx(DaggerType, 2, True, True)
	Endif

	If GetActorBase() == ZSH_Tomb_Warrior03
		DoCombatSpellApply(ConjureFrostAtronach, Self)
	Endif

	If GetActorBase() == ZSH_Tomb_Warrior04
		DoCombatSpellApply(ConjureFlameAtronach, Self)
		DoCombatSpellApply(ConjureFlameAtronach, Self)
	Endif
EndFunction

Event OnEnterBleedout()
	SetNoBleedoutRecovery(True)
	StopCombat()
	SetAV("Aggression", 0)
	SetGhost()
	DispelAllSpells()
	(ZSH_BlackstedQuest as ZSH_V2_QuestScript01).HeroDeath(Self)

	While !(ZSH_BlackstedQuest.GetStage() == 60)
		Utility.Wait(0.1)
	EndWhile

	GetLinkedRef().Enable()
	Utility.Wait(0.1)
	SetNoBleedoutRecovery(False)
	RestoreAV("Health", 9999)
	EvaluatePackage()

	While Self.GetSitState() < 3
		Utility.Wait(0.1)
	EndWhile

	(ZSH_BlackstedQuest as ZSH_V2_QuestScript01).HeroReady(Self as Actor)

	While ZSH_BlackstedQuest.GetStage() < 90
		Utility.Wait(0.1)
	EndWhile

	Delete()
EndEvent
